Package com.google.protobuf

# Class GeneratedMessageV3.ExtendableMessage<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>

java.lang.Object
com.google.protobuf.AbstractMessageLite
com.google.protobuf.AbstractMessage
com.google.protobuf.GeneratedMessageV3
com.google.protobuf.GeneratedMessageV3.ExtendableMessage<MessageT>

All Implemented Interfaces:
  `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT>`, `Message`, `MessageLite`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `Serializable`

Direct Known Subclasses:
  `DescriptorProtos.EnumOptions`, `DescriptorProtos.EnumValueOptions`, `DescriptorProtos.ExtensionRangeOptions`, `DescriptorProtos.FieldOptions`, `DescriptorProtos.FileOptions`, `DescriptorProtos.MessageOptions`, `DescriptorProtos.MethodOptions`, `DescriptorProtos.OneofOptions`, `DescriptorProtos.ServiceOptions`

Enclosing class:
  GeneratedMessageV3

public abstract static class GeneratedMessageV3.ExtendableMessage<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>> extends GeneratedMessageV3 implements GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT>
Generated message classes for message types that contain extension ranges subclass this.

This class implements type-safe accessors for extensions. They implement all the same operations that you can do with normal fields -- e.g. "has", "get", and "getCount" -- but for extensions. The extensions are identified using instances of the class `GeneratedMessage.GeneratedExtension`; the protocol compiler generates a static instance of this class for every extension in its input. Through the magic of generics, all is made type-safe.

For example, imagine you have the `.proto` file:

     option java_class = "MyProto";

     message Foo {
       extensions 1000 to max;
     }

     extend Foo {
       optional int32 bar;
     }

Then you might write code like:

     MyProto.Foo foo = getFoo();
     int i = foo.getExtension(MyProto.bar);

See also `GeneratedMessageV3.ExtendableBuilder`.

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`GeneratedMessageV3.ExtendableMessage.ExtensionWriter`
Used by subclasses to serialize extensions.

## Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessageV3

`GeneratedMessageV3.Builder<BuilderT extends GeneratedMessageV3.Builder<BuilderT>>, GeneratedMessageV3.BuilderParent, GeneratedMessageV3.ExtendableBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>,BuilderT extends GeneratedMessageV3.ExtendableBuilder<MessageT,BuilderT>>, GeneratedMessageV3.ExtendableMessage<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>, GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>, GeneratedMessageV3.FieldAccessorTable, GeneratedMessageV3.UnusedPrivateParameter`

## Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessageLite

`AbstractMessageLite.InternalOneOfEnum`

## Field Summary

### Fields inherited from class com.google.protobuf.GeneratedMessageV3

`alwaysUseFieldBuilders, unknownFields`

### Fields inherited from class com.google.protobuf.AbstractMessage

`memoizedSize`

### Fields inherited from class com.google.protobuf.AbstractMessageLite

`memoizedHashCode`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`ExtendableMessage()`
`protected`
`ExtendableMessage(GeneratedMessageV3.ExtendableBuilder<MessageT,?> builder)`

## Method Summary

Modifier and Type
Method
Description
`protected boolean`
`extensionsAreInitialized()`
Called by subclasses to check if all extensions are initialized.
`protected int`
`extensionsSerializedSize()`
Called by subclasses to compute the size of extensions.
`protected int`
`extensionsSerializedSizeAsMessageSet()`
`Map<Descriptors.FieldDescriptor,Object>`
`getAllFields()`
Returns a collection of all the fields in this message which are set and their corresponding values.
`Map<Descriptors.FieldDescriptor,Object>`
`getAllFieldsRaw()`
`final <T> T`
`getExtension(Extension<MessageT,List<T>> extension, int index)`
Get one element of a repeated extension.
`final <T> T`
`getExtension(Extension<MessageT,T> extension)`
Get the value of an extension.
`final <T> T`
`getExtension(ExtensionLite<MessageT,List<T>> extensionLite, int index)`
Get one element of a repeated extension.
`final <T> T`
`getExtension(ExtensionLite<MessageT,T> extensionLite)`
Get the value of an extension.
`final <T> T`
`getExtension(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension, int index)`
Get one element of a repeated extension.
`final <T> T`
`getExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)`
Get the value of an extension.
`final <T> int`
`getExtensionCount(Extension<MessageT,List<T>> extension)`
Get the number of elements in a repeated extension.
`final <T> int`
`getExtensionCount(ExtensionLite<MessageT,List<T>> extensionLite)`
Get the number of elements in a repeated extension.
`final <T> int`
`getExtensionCount(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension)`
Get the number of elements in a repeated extension.
`protected Map<Descriptors.FieldDescriptor,Object>`
`getExtensionFields()`
`Object`
`getField(Descriptors.FieldDescriptor field)`
Obtains the value of the given field, or the default value if it is not set.
`Object`
`getRepeatedField(Descriptors.FieldDescriptor field, int index)`
Gets an element of a repeated field.
`int`
`getRepeatedFieldCount(Descriptors.FieldDescriptor field)`
Gets the number of elements of a repeated field.
`final <T> boolean`
`hasExtension(Extension<MessageT,T> extension)`
Check if a singular extension is present.
`final <T> boolean`
`hasExtension(ExtensionLite<MessageT,T> extensionLite)`
Check if a singular extension is present.
`final <T> boolean`
`hasExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)`
Check if a singular extension is present.
`boolean`
`hasField(Descriptors.FieldDescriptor field)`
Returns true if the given field is set.
`boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`protected void`
`makeExtensionsImmutable()`
Used by parsing constructors in generated classes.
`protected GeneratedMessageV3.ExtendableMessage<MessageT>.ExtensionWriter`
`newExtensionWriter()`
`protected GeneratedMessageV3.ExtendableMessage<MessageT>.ExtensionWriter`
`newMessageSetExtensionWriter()`
`protected boolean`
`parseUnknownField(CodedInputStream input, UnknownFieldSet.Builder unknownFields, ExtensionRegistryLite extensionRegistry, int tag)`
Called by subclasses to parse an unknown field.
`protected boolean`
`parseUnknownFieldProto3(CodedInputStream input, UnknownFieldSet.Builder unknownFields, ExtensionRegistryLite extensionRegistry, int tag)`
Delegates to parseUnknownField.

### Methods inherited from class com.google.protobuf.GeneratedMessageV3

`canUseUnsafe, computeStringSize, computeStringSizeNoTag, emptyBooleanList, emptyDoubleList, emptyFloatList, emptyIntList, emptyLongList, getDescriptorForType, getOneofFieldDescriptor, getParserForType, getSerializedSize, getUnknownFields, hasOneof, internalGetFieldAccessorTable, internalGetMapField, isStringEmpty, makeMutableCopy, mergeFromAndMakeImmutableInternal, mutableCopy, mutableCopy, mutableCopy, mutableCopy, mutableCopy, newBooleanList, newBuilderForType, newBuilderForType, newDoubleList, newFloatList, newInstance, newIntList, newLongList, parseDelimitedWithIOException, parseDelimitedWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag, writeTo`

### Methods inherited from class com.google.protobuf.AbstractMessage

`equals, findInitializationErrors, getInitializationErrorString, hashBoolean, hashCode, hashEnum, hashEnumList, hashFields, hashLong, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite

`addAll, addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.GeneratedMessageV3.ExtendableMessageOrBuilder

`getDefaultInstanceForType`

### Methods inherited from interface com.google.protobuf.Message

`newBuilderForType, toBuilder`

### Methods inherited from interface com.google.protobuf.MessageLite

`toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getDescriptorForType, getInitializationErrorString, getOneofFieldDescriptor, getUnknownFields, hasOneof`

## Constructor Details

### ExtendableMessage

protected ExtendableMessage()

### ExtendableMessage

protected ExtendableMessage(GeneratedMessageV3.ExtendableBuilder<MessageT,?> builder)

## Method Details

### hasExtension

public final <T> boolean hasExtension(ExtensionLite<MessageT,T> extensionLite)
Check if a singular extension is present.

Specified by:
  `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtensionCount

public final <T> int getExtensionCount(ExtensionLite<MessageT,List<T>> extensionLite)
Get the number of elements in a repeated extension.

Specified by:
  `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(ExtensionLite<MessageT,T> extensionLite)
Get the value of an extension.

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(ExtensionLite<MessageT,List<T>> extensionLite, int index)
Get one element of a repeated extension.

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### hasExtension

public final <T> boolean hasExtension(Extension<MessageT,T> extension)
Check if a singular extension is present.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### hasExtension

public final <T> boolean hasExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)
Check if a singular extension is present.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `hasExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtensionCount

public final <T> int getExtensionCount(Extension<MessageT,List<T>> extension)
Get the number of elements in a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtensionCount

public final <T> int getExtensionCount(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension)
Get the number of elements in a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtensionCount` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(Extension<MessageT,T> extension)
Get the value of an extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(GeneratedMessage.GeneratedExtension<MessageT,T> extension)
Get the value of an extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(Extension<MessageT,List<T>> extension, int index)
Get one element of a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### getExtension

public final <T> T getExtension(GeneratedMessage.GeneratedExtension<MessageT,List<T>> extension, int index)
Get one element of a repeated extension.

TODO(b/258340024): handled by ExtensionLite version

Specified by:
  `getExtension` in interface `GeneratedMessageV3.ExtendableMessageOrBuilder<MessageT extends GeneratedMessageV3.ExtendableMessage<MessageT>>`

### extensionsAreInitialized

protected boolean extensionsAreInitialized()
Called by subclasses to check if all extensions are initialized.

### isInitialized

public boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessageV3`

### parseUnknownField

protected boolean parseUnknownField(CodedInputStream input, UnknownFieldSet.Builder unknownFields, ExtensionRegistryLite extensionRegistry, int tag) throws IOException
Description copied from class: `GeneratedMessageV3`
Called by subclasses to parse an unknown field.

TODO(b/248153893) remove this method

Overrides:
  `parseUnknownField` in class `GeneratedMessageV3`
Returns:
  `true` unless the tag is an end-group tag.
Throws:
  `IOException`

### parseUnknownFieldProto3

protected boolean parseUnknownFieldProto3(CodedInputStream input, UnknownFieldSet.Builder unknownFields, ExtensionRegistryLite extensionRegistry, int tag) throws IOException
Delegates to parseUnknownField. This method is obsolete, but we must retain it for compatibility with older generated code.

TODO(b/248153893): remove mutating method from immutable type

Overrides:
  `parseUnknownFieldProto3` in class `GeneratedMessageV3`
Throws:
  `IOException`

### makeExtensionsImmutable

protected void makeExtensionsImmutable()
Used by parsing constructors in generated classes.

TODO(b/258340024): remove unused method (extensions should be immutable after build)

Overrides:
  `makeExtensionsImmutable` in class `GeneratedMessageV3`

### newExtensionWriter

protected GeneratedMessageV3.ExtendableMessage<MessageT>.ExtensionWriter newExtensionWriter()

### newMessageSetExtensionWriter

protected GeneratedMessageV3.ExtendableMessage<MessageT>.ExtensionWriter newMessageSetExtensionWriter()

### extensionsSerializedSize

protected int extensionsSerializedSize()
Called by subclasses to compute the size of extensions.

### extensionsSerializedSizeAsMessageSet

protected int extensionsSerializedSizeAsMessageSet()

### getExtensionFields

protected Map<Descriptors.FieldDescriptor,Object> getExtensionFields()

### getAllFields

public Map<Descriptors.FieldDescriptor,Object> getAllFields()
Description copied from interface: `MessageOrBuilder`
Returns a collection of all the fields in this message which are set and their corresponding values. A singular ("required" or "optional") field is set iff hasField() returns true for that field. A "repeated" field is set iff getRepeatedFieldCount() is greater than zero. The values are exactly what would be returned by calling `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` for each field. The map is guaranteed to be a sorted map, so iterating over it will return fields in order by field number.
If this is for a builder, the returned map may or may not reflect future changes to the builder. Either way, the returned map is itself unmodifiable.

Specified by:
  `getAllFields` in interface `MessageOrBuilder`
Overrides:
  `getAllFields` in class `GeneratedMessageV3`

### getAllFieldsRaw

public Map<Descriptors.FieldDescriptor,Object> getAllFieldsRaw()

### hasField

public boolean hasField(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Returns true if the given field is set. This is exactly equivalent to calling the generated "has" accessor method corresponding to the field.

Specified by:
  `hasField` in interface `MessageOrBuilder`
Overrides:
  `hasField` in class `GeneratedMessageV3`

### getField

public Object getField(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Obtains the value of the given field, or the default value if it is not set. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned. For repeated fields, a java.util.List is returned.

Specified by:
  `getField` in interface `MessageOrBuilder`
Overrides:
  `getField` in class `GeneratedMessageV3`

### getRepeatedFieldCount

public int getRepeatedFieldCount(Descriptors.FieldDescriptor field)
Description copied from interface: `MessageOrBuilder`
Gets the number of elements of a repeated field. This is exactly equivalent to calling the generated "Count" accessor method corresponding to the field.

Specified by:
  `getRepeatedFieldCount` in interface `MessageOrBuilder`
Overrides:
  `getRepeatedFieldCount` in class `GeneratedMessageV3`

### getRepeatedField

public Object getRepeatedField(Descriptors.FieldDescriptor field, int index)
Description copied from interface: `MessageOrBuilder`
Gets an element of a repeated field. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned.

Specified by:
  `getRepeatedField` in interface `MessageOrBuilder`
Overrides:
  `getRepeatedField` in class `GeneratedMessageV3`